<?php
include("admin/inc/rehtmlentities.inc.php");

function URLadd($text)
   {
   $urlsuch[]="/([^]_a-z0-9-=\"'\/])((https?|ftp):\/\/|www\.)([^ \r\n\(\)\^\$!`\"'\|\[\]\{\}<>]*)/si";
   $urlsuch[]="/^((https?|ftp):\/\/|www\.)([^ \r\n\(\)\^\$!`\"'\|\[\]\{\}<>]*)/si";

   $urlreplace[]="\\1[URL]\\2\\4[/URL]";
   $urlreplace[]="[URL]\\1\\3[/URL]";


   $emailsuch[]="/([\s])([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
   $emailsuch[]="/^([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";

   $emailreplace[]="\\1[EMAIL]\\2[/EMAIL]";
   $emailreplace[]="[EMAIL]\\0[/EMAIL]";
    
   $text = preg_replace($urlsuch, $urlreplace, $text);
   if (strpos($text, "@")) $text = preg_replace($emailsuch, $emailreplace, $text);
    return $text;
   } //Aus http://link.de wird [URL]http://link.de[/URL] ENDE


//E-Mail Adressen und Links werden anklickbar

function URL_email($text)
   {
   $text = preg_replace("/\[URL\]www.(.*?)\[\/URL\]/si", "<a target=\"_blank\" href=\"http://www.\\1\">www.\\1</a>", $text);
    $text = preg_replace("/\[URL\](.*?)\[\/URL\]/si", "<a target=\"_blank\" href=\"\\1\">\\1</a>", $text);

   $text = preg_replace("/\[URL=www.(.*?)\](.*?)\[\/URL\]/si", "<a target=\"_blank\" href=\"http://www.\\1\">\\2</a>", $text);
   $text = preg_replace("/\[URL=(.*?)\](.*?)\[\/URL\]/si", "<a target=\"_blank\" href=\"\\1\">\\2</a>", $text);



   //E-Mail &auml;ndern
   $text = preg_replace("/\[EMAIL\](.*?)\[\/EMAIL\]/si", "<a href=\"mailto:\\1\">\\1</a>", $text);
   $text = preg_replace("/\[EMAIL=(.*?)\](.*?)\[\/EMAIL\]/si", "<a href=\"mailto:\\1\">\\2</a>", $text);

   //ICQ/AIM/MSN
   $text = preg_replace("/\[ICQ\](.*?)\[\/ICQ\]/si", "<a href=\"http://wwp.icq.com/scripts/search.dll?to=\\1\">\\1</a>", $text);
   $text = preg_replace("/\[MSN\](.*?)\[\/MSN\]/si", "<a href=\"http://members.msn.com/?mem=\\1\">\\1</a>", $text);
   $text = preg_replace("/\[AIM\](.*?)\[\/AIM\]/si", "<a href=\"aim:goim?screenname=\\1&message=Hi.+Are+you+there?\">\\1</a>", $text);

   $text = preg_replace("/\[YIM\](.*?)\[\/YIM\]/si", "<a href=\"http://edit.yahoo.com/config/send_webmesg?.target=\\1&.src=pg\">\\1</a>", $text);

    return $text;
   } //E-Mail Adressen und Links werden anklickbar ENDE


//Image
function image($text)
   {
   $text = preg_replace("/\[IMG\](.*?)\[\/IMG\]/si", "<img src=\"\\1\" border=\"0\">", $text);
   return $text;
   }






//BB-Codes
function bb_codes($text)
   {

   $text = preg_replace_callback("/\[PHP\](.*?)\[\/PHP\]/si", "php_codes", $text);
   $text = preg_replace_callback("/\[CODE\](.*?)\[\/CODE\]/si", "codes", $text);

   $text = preg_replace("/\[b\](.*?)\[\/b\]/si", "<b>\\1</b>", $text);
   $text = preg_replace("/\[i\](.*?)\[\/i\]/si", "<i>\\1</i>", $text);
   $text = preg_replace("/\[u\](.*?)\[\/u\]/si", "<u>\\1</u>", $text);


   $text = preg_replace("/\[CENTER\](.*?)\[\/CENTER\]/si", "<div align=\"center\">\\1</div>", $text);
   $text = preg_replace("/\[ALIGN\=CENTER\](.*?)\[\/ALIGN\]/si", "<div align=\"center\">\\1</div>", $text);

   $text = preg_replace("/\[SIZE=(8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27)\](.*?)\[\/SIZE\]/si", "<span style=\"font-size:\\1px\">\\2</span>", $text);



    while(eregi("\[COLOR=(.*)\](.*)\[\/COLOR\]",$text)) $text = preg_replace("/\[COLOR=(.*?)\](.*?)\[\/COLOR\]/si", "<font color=\"\\1\">\\2</font>", $text);

    $text = preg_replace("/\[list\](.*?)\[\/list\]/si", "<ul>\\1</ul>", $text);

    $text = preg_replace("/\[\*\]/si", "<li>", $text);





   $zitat = "
   <table align=\"center\" width=\"98%\" cellpadding=\"5\" cellspacing=\"1\" border=\"0\" class=\"cbtbbgcolorstyle\">

   <tr class=\"cbtbkopfstyle\">
    <td>Zitat:</td>
   </tr>
   <tr class=\"cbtbspalte1style\">
    <td>\\1</td>
   </tr>

   </table> ";


   while(eregi("\[QUOTE\](.*)\[\/QUOTE\]",$text)) $text = preg_replace("/\[QUOTE\](.*?)\[\/QUOTE\]/si", $zitat, $text);



   return $text;
   } //BB_Codes Ende

function codes($text)
   {
   $code = trim($text[1]);


   $zeilen = substr_count($code, "<br>");
   $zeilen++;

   $code = str_replace("<br>","",$code);

   $height= $zeilen * 15 + 65;

   if($zeilen >= 30)
      {
      $height= 30 * 15 + 50;
      }

   $ausgabe .= "
<table align=\"center\" style=\"width:98%; table-layout: fixed;\" cellpadding=\"0\" cellspacing=\"0\" >
<tr class=\"cbtbkopfstyle\">
<td><b>&nbsp;Code</b><font size=\"+1\">&nbsp;</font></td>
</tr>

 <tr>
  <td><div style=\"overflow: auto; height: ".$height."px; width: 100%;\">
   <table  cellpadding=\"4\" cellspacing=\"1\" style=\"width:100%\" class=\"cbtableinborder\">
    <tr valign=\"top\" class=\"cbtbspalte1style\">
     <td  nowrap=\"nowrap\" align=\"right\"><pre>";

   $a = 0;
   while($a < $zeilen)
      {
      $a++;
      $ausgabe .= $a.":\n";
        }
   $ausgabe .= "</pre></td><td  valign=\"top\" nowrap=\"nowrap\" align=\"left\" style=\"width:100%\"> <pre>";
   $ausgabe .= $code;

   $ausgabe .=  "</pre></td>
    </tr>
   </table>
  </div></td>
 </tr>
</table>
";


   return $ausgabe;
   }


function php_codes($text)
   {

   $code = trim($text[1]);

   $code = str_replace("&lt;br&gt;","{_|_br_|_}",$code);
   $code = str_replace("&lt;","<",$code);
   $code = str_replace("&gt;",">",$code);


   $zeilen = substr_count($code, "<br>");
   $zeilen++;



   $height= $zeilen * 15 + 65;

   if($zeilen >= 30)
      {
      $height= 30 * 15 + 50;
      }

$php_code .= "
<table align=\"center\" style=\"width:98%; table-layout: fixed;\" cellpadding=\"0\" cellspacing=\"0\" >
<tr class=\"cbtbkopfstyle\">
<td><b>&nbsp;PHP</b><font size=\"+1\">&nbsp;</font></td>
</tr>

 <tr>
  <td><div style=\"overflow: auto; height: ".$height."px; width: 100%;\">
   <table  cellpadding=\"4\" cellspacing=\"1\" style=\"width:100%\" class=\"cbtableinborder\">
    <tr valign=\"top\" class=\"cbtbspalte1style\">
     <td  nowrap=\"nowrap\" align=\"right\"><pre>";

   $a = 0;
   while($a < $zeilen)
      {
      $a++;
      $php_code .= $a;
      $php_code .= ":\n";
      }
   $php_code .= "</pre></td><td  valign=\"top\" nowrap=\"nowrap\" align=\"left\" style=\"width:100%\">";


#$code = htmlentities($code);
#$code = stripslashes($code);

   $code = trim($code);
   $code = str_replace("&lt;","<",$code);
   $code = str_replace("&gt;",">",$code);
   $code = str_replace("<br>", "\n", $code);
   $code = rehtmlentities($code);

   $code = str_replace("{_|_br_|_}", "<br>", $code);


$php_code .= highlight_string($code, true);




$php_code .=  "</td>
    </tr>
   </table>
  </div></td>
 </tr>
</table>
";




   $ausgabe_php_code = $php_code;

   return $ausgabe_php_code;
   }

//Zeilenumbruch und &auml;hnliches
function sonstiges($text)
   {
   $text = htmlentities($text,ENT_NOQUOTES);
   $text = str_replace("\n", "<br>", $text);
   return $text;
   } //Sonstiges Ende


//Smilies
function smilies($text, $nr)
   {
   $smiliedb = "ccb".$nr."_smilies";
   $abfrage = "SELECT * FROM $smiliedb";
   $ergebnis = mysql_query($abfrage);
   while($row = mysql_fetch_object($ergebnis))
      {
      $text = str_replace("$row->alias", "<img border=\"0\" src=\"$row->smilie\">", $text);

      }

   return $text;
   } //Smilies Ende





?>
